
BIBUTILS

5.0
05/27/13

USER VISIBLE CHANGES
+ Make default character set unicode
+ Enable -o --output-encoding for the xxx2xml converters

BUILD
+ Ensure binary directory target exists (reported by Thomas Fischer)
+ Tell cp to preserve symbolic links when copying dynamic library (reported by Thomas Fischer)
+ Remove bashisms from sh script (reported by JeffH)

BIBLATEXIN
+ Handle 'shorttitle' tag (reported by Nick Bart)
+ Make asis/corp file work again (reported by JeffH)
+ Map 'pubstate' tag to note type="publication status" similar to http://ufdc.ufl.edu/help/pubstatus (suggested by Nick Bart)
+ Handle 'series' tag in @report (reported by Nick Bart)
+ Map 'series' in @article to partName of journal title (reported by Nick Bart)
+ Write 'annotation' as special type of note (reported by Nick Bart)

BIBTEXIN
+ Make asis/corp file work again (reported by JeffH)

RISOUT
+ Ensure that BT fields are written for conference publications (reported by Matthias Stevens)
+ Ensure that ED fields are used for editors of conference publications (reported by Matthias Stevens)

MODS
+ Fix inappropriate "language" tags under languageOfCataloging (reported by Nick Bart)

NAME MANGLING
+ Improve handling of prefixes to given names, e.g. "van der" in "van der Sande"

4.17
01/24/13

BUILD
+ Large changes to build process; more changes for MINGW32/Cygwin
+ Remove attempt to build powerpc-supporting binaries for MacOSX

GLOBAL
+ Attempt to include iso639-2b codes for languages when possible
+ Make output consistent with MODS version 3.4 by adding language/languageTerm (reported by Nick Bart)
+ Fix accidental duplication of roles in MODS output (reported by Nick Bart)

BIBLATEXIN
+ Map 'hyphenation' to recordInfo/languageOfCataloging (reported by Nick Bart)
+ Map biblatex 'version' to edition (reported by Nick Bart)
+ Fix series fields in @inbook (reported by Nick Bart)
+ Fix issues with @periodical (reported by Nick Bart)
+ Handle entrysubtypes for @article (reported by Nick Bart)
+ Handle origdate (reported by Nick Bart)
+ Fix corporate editors (reported by Nick Bart)
+ Process report 'isrn' field (reported by Nick Bart)

MEDIN
+ Handle iso639-2b language input and output as full language name

4.16
01/09/13

BUILD
+ Add version to GPL for Fedora/Redhat
+ Add recognition of x86_64 MacOSX as Intel Macintoshes to configure
+ Add recognition of OpenBSD to configure
+ Add recognition of MINGW32 architecture to configure
+ Remove explicit use of 'make' in Makefiles and use $(MAKE) instead
+ Switch to sh version of configure script (thanks to Adrian Devries)
+ Switch to sh version of maketgz script (thanks to Adrian Devries)
+ Switch to sh version of makedeb script

GLOBAL
+ Improve propagation of memory errors in libraries to calling programs
+ Update help messages
+ Rewrite name parsing/mangling code
+ Do cast for ctype.h functions to handle MINGW32 architecture (reported by Adrian Devries)

ADSOUT
+ Fix bug where partial matches for journal titles identified journals
+ Add Windows-specific format string for MINGW32 architecture (reported by Adrian Devries)
+ Update list of journal abbreviations

BIBTEXIN
+ Fix bug where spaces following an escaped quotation mark (as with the -nl, no latex, flag) are lost (reported by Raoul Blankertz)
+ Fix bug where pages had to be completely numeric (reported by Nick Bart)
+ Import series information for @Techreport
+ Rewrite name parsing
+ Improve recognition of urls put in inappropriate fields
+ Improve handling of tilde/sticky space
+ Add latex recognition of alternative ways to express the (Polish) capital and lowercase slashed L
+ Improve recognition of URL identifiers in note fields
+ Map 'howpublished' to publisher (reported by Nick Bart)

BIBLATEXIN
+ Add 'date' field to every reference type, regardless if it's in the reference documentation or not (reported by Nick Bart)
+ Fix bug where pages had to be completely numeric (reported by Nick Bart)
+ Add support for 'institution' and 'type' for report references (reported by Nick Bart)
+ Add strings support (reported by Nick Bart)
+ Handle editor types, including bibtex-chicago variants (reported by Nick Bart)
+ Map 'introduction', 'foreward', 'afterward' to "author of introduction/foreward/afterward" (reported by Nick Bart)
+ Ignore 'school' in biblatexin reference if 'institution' is available like biblatex(reported by Nick Bart)
+ Improve biblatex thesis type recognition
+ Rewrite name parsing
+ Improve handlning of tilde/sticky space
+ Map 'howpublished' to publisher (reported by Nick Bart)
+ Handle 'titleaddon' field (reported by Nick Bart)
+ Output number field differently for type report (reported by Nick Bart)

BIBTEXOUT
+ Output series information for @Techreport
+ Output all keywords in single entry as semi-colon deliminated list

COPACIN
+ Fix pre-name mangling that prevents recognition by asis/corporation lists

ENDIN
+ Add better support for series information

ENDOUT
+ Add better support for series information

MODSIN
+ Add support for common MARC role codes (role abbreviations)

RISIN
+ Add recognition of map type
+ Improve support for series information (reported by Mattheis Steffens)

RISOUT
+ Add recognition of map type (reported by Mattheis Steffens)
+ Fix bug in date output (reported by Mattheis Steffens)
+ Improve support for series information (reported by Mattheis Steffens)

4.15
9/26/12

BIBTEXIN
+ @article 'number' -> MODS 'issue'
+ @conference = @inproceedings
+ 'organization' -> publisher if publisher not available, otherwise output
  as <name><namePart>xx</namePart><role><roleTerm>organizer of meeting</roleTerm></role></name>

BIBLATEXIN
+ Add missing month parsing

4.14
9/04/12

BIBTEXIN
+ Split individual keywords in the keywords field separated by semi-colons

RISIN
+ Handle URL schemes from L1 and L4 fields (reported by Martin Kucej)

RISOUT
+ PY outputs only year, DA outputs year/month/day combination (reported by Nelson Hart)
+ L1 and L4 fields need to be URL's (reported by Martin Kucej)

WORD2007OUT
+ Replace b:PeriodicalName with b:PeriodicalTitle

4.13
8/28/12

BUILD
+ Fix build problem with test subdirectory (patch by David Bremner)
+ Avoid hard-coded dynamic library to help out Debian (path by David Bremner)
+ Add patch to bibutils.dbk (patch by David Bremner)

CHARSETS
+ Add more latex character <-> Unicode conversions

FIELDS
+ Update internals, add vplist component, and convert to new interface

BIBTEXIN
+ Fix chapter in @inbook, @inproceedings, and @incollection from overwriting
  the title of the section being cited (reported by Brian Keese)
+ Cleanly handle "illegal" @inbook entries that have both "title" and "booktitle"
  fields and really want to be @incollection entries (reported by Brian Keese)
+ Remove mbox commands from input

RISIN
+ Add recognition of more RIS fields (reported by Nelson Hart)

RISOUT
+ Use 'AB' instead of 'N2' tag for abstracts (reported by Nelson Hart)
+ Use 'DO' tag instead of building a complete URL for DOI's (reported by Nelson Hart)
+ Use 'ET' tag for edition output (reported by Nelson Hart)
+ Use 'LA' tag for language
+ Add recognition of non-official genres "book chapter" and "journal article"
  (reported by Nelson Hart)


4.12
10/10/10

BUILD
+ Allow smaller static libraries to be built
+ Add --dynamic and --static (default) options to configure script
+ Add --install-lib to configure script to controll installation of dynamic libraries

XML2ADS
+ Fix overflow of page value with really large page numbers
+ Update journal abbreviation list

XML2BIB
+ Add command-line option -d or --drop-key to prevent xml2bib from
  adding tags (so they can be generated by programs like JabRef)


4.11
9/14/10

BUILD
+ Include some "unused" flags like LDFLAGS so that people with particular build
  environments can have these flags respected (from Gentoo 
  http://bugs.gentoo.org/show_bug.cgi?id=336237)
+ Add test programs to "make test" protocol

TEST
+ Fix some signedness issues (bit rot) in the test programs (from Mandriva
  packager, Stéphane Téletchéa)

XML2BIB
+ Add command-line option  -at or --abbreviatedtitles to force xml2bib to
  use abbreviated titles for journals (books and other host types), if present
  in the MODS input


4.10
8/30/10

BIBLATEX2XML
+ fix organization/event handling (thanks to Johannes Wilms)

MODSIN
+ support the presence of the reference identifier/key in 
  mods:recordInfo:recordIdentifier

4.9
4/9/10

BIBLATEX2XML
+ Many, many changes thanks to Johannes Wilms

BIB2XML
+ Some improvements in thesis handling derived from biblatex2xml changes

BUILD
+ Fix build for _x86_64 (amd64) (Thanks to patch from Colin Bell).


4.8
2/2/10

BIB2XML
+ Handle bibtex annote tags

XML2BIB
+ Handle bibtex annote tags


4.7
12/11/09

XML2ADS
+ Fix not outputting multiple authors from "ASIS" and "CORP" categories.

XML2END
+ Fix not outputting multiple authors from "ASIS" and "CORP" categories.

XML2ISI
+ Fix not outputting multiple authors from "ASIS" and "CORP" categories.

4.6
11/2/09

BIB2XML
+ Fix inefficiency in latex2char() that gives roughly a 10x speed increase
  in bib2xml.  Thanks to Stephan Washietl for the patch.

NAME MANGLING
+ Fix bug with uninitalized pointer.  Thanks to David Bremner for patch.

NEWSTRING
+ Add newstrs versions of various commands.


4.5
10/24/09

BIB2XML
+ Identify and use byte-order-mark in UTF8-encoded files
+ Support file attachments with "pdf" tags (old JabRef), "sentelink" (Sente),
  and "file" (new JabRef, Zotero, Mendeley).  (Thanks to Richard Karnesky)

COPAC2XML
+ Identify and use byte-order-mark in UTF8-encoded files

ISI2XML
+ Identify and use byte-order-mark in UTF8-encoded files

RIS2XML
+ Add support for DOI tags DO and DI from Scopus (Thanks to Fred Howell)
+ Identify and use byte-order-mark in UTF8-encoded files
+ Add support for L1 file attachment tags (Thanks to Richard Karnesky)

XML2ADS
+ Output file attachments as URLs

XML2BIB
+ Add support for "file" file attachment tag in the JabRef/Mendeley/Zotero
  format

XML2END
+ Output file attachments as URLs

XML2ISI
+ Output file attachments as URLs

XML2RIS
+ Add support for L1 file attachment tags

4.4
10/05/2009

BIB2XML
+ Add -nt --nosplit-title command line option to avoid splitting titles
  with colons or question marks into title/subtitle MODS pairs

COPAC2XML
+ Add -nt --nosplit-title command line option to avoid splitting titles
  with colons or question marks into title/subtitle MODS pairs

END2XML
+ Add -nt --nosplit-title command line option to avoid splitting titles
  with colons or question marks into title/subtitle MODS pairs
+ Add support for electronic-source-num as potential location of DOI
+ Add support for language

END2XML
+ Fix support for number field in report/book/book section/edited book
  reference types

ENDXML2XML
+ Support pdf-url in endnote XML file

ISI2XML
+ Add -nt --nosplit-title command line option to avoid splitting titles
  with colons or question marks into title/subtitle MODS pairs

RIS2XML
+ Add -nt --nosplit-title command line option to avoid splitting titles
  with colons or question marks into title/subtitle MODS pairs


4.3
7/31/09

BIB2XML
+ Add support for recognizing howpublished = {arXiv:xxxx} entries

LATEX
+ Fix bug for {\c{c}} output

XML2END
+ Add support for Pubmed ID's (PMID) as %U http://www.ncbi.nlm.nih.gov/pubmed/...
+ Add support for arXiv identifiers as %U http://arxiv.org/abs/...

XML2RIS
+ Add support for Pubmed ID's (PMID) as UR - http://www.ncbi.nlm.nih.gov/pubmed/..
+ Add support for arXiv identifiers as UR - http://arxiv.org/abs/...
+ Change abstract output from "AB" tag to "N2"

XML2WORDBIB
+ Add support to handle inventors in patent type
+ Fix inappropriate output of empty author or editor lists

4.2
06/25/09

BUILD
+ Add support for 'Power Macintosh' as MacOSX_ppc.  Thanks to Matthias
  Steffens for the fix.
+ Fix additional MacOSX build bugs, thanks to David Sanson

END2XML
+ Add %1 parsing to journal articles
+ Fix bug not recognizing %[ and elements as valid tags
+ Add support for Conference Paper

ENDX2XML
+ Add support for pub-location tags
+ Add support for Conference Paper

LATEX
+ Fix bug for {\AA} conversion, patch thanks to Joseph Barillari.

MED2XML
+ Recognized medline entries from MEDLINE in addition to PUBMED.  Thanks to
  Hamish McWilliam for providing useful information.

MODSIN
+ Handle pages provided as list, patch thanks to Heiko Jansen

NAME MANGLING
+ Handle hyphenated names better
+ Handle "et al." in name lists better

XML2BIB
+ Add recognition of genre "article", patch thanks to Heiko Jansen

XML2END
+ Add export of DOI as %U http://dx.doi.org/.... Thanks to Mattheis
  Steffens for the report

XML2RIS
+ Add export of DOI as UR  - http://dx.doi.org/....  Thanks to Mattheis
  Steffens for the report

XML2WORD
+ Add support for more types of sources.


4.1

BIBLATEX2XML
+ Lots of bug fixes

BUILD
+ Try to make changes to bin/Makefile to fix problem on FreeBSD.  Still
  awaiting feedback to see if problem is solved.

END2XML
+ Handle DOI placed in %1 custom field by Wiley

RIS2XML
+ Add pattern matching for new DOI output by Science Direct

XML2ADS
+ Fix putting comma after the first keyword (thanks to Richard Mathar)

4.0

BIBLATEX2XML
+ Initial alpha version of the program -- mapping certain fields to MODS
  hasn't been done yet.

BUILD
+ Move files/functions around so all of the code necessary to support
  the converters but not part of the bibutils libraries are in the
  bin subdirectory.

CHARSET CONVERSION
+ add partial recognition of Chinese GB18030 character set (containing 
  the GBK superset)
+ Revert 3.41 patch from Luc Pardon default that made unicode/utf8 take
  precedence over latex now that -nl, --no-latex flag is available

END2XML
+ support %G language tag
+ support %H translator tag

ENDX2XML
+ fix bug caused by style tags in author fields

LIBRARY HANDLING
+ Remove requirement for defining lists for "as-is" and "corporation" names
  to be read from the file -- embed in the param structure instead (help
  for Haskell bindings)
+ Modify the library API so that input and output formats are stored in
  struct param and do not need to be repeated in bibl_read() and bibl_write()
  calls.

XML2BIB
+ Turn off latex encoding if we're using the GB18030 character set.

XML2END
+ support %G language tag
+ support %H translator tag
+ add better support for MARC-authority genre tags

3.43
11/24/08

BIB2XML
+ Fix recognition of em-dash by placing it before en-dash in conversion
  list.
+ Add -nl or --no-latex to prevent conversion of latex character
  combinations

MODSOUT
+ Ensure that bibutils handles records with empty MODS attributes

3.42
10/31/08

MODSOUT
+ Change default to UTF8 unicode characters written directly (not
  via XML entities) and writing BOM.  Add command-line switch
  -x or --xml-entities to write XML entities instead to BIB2XML
  END2XML ENDX2XML MED2XML RIS2XML, etc.

XML2ADS
+ Fix unicode output to add Byte Order Mark by default
+ Add -nb or --no-bom switch to turn off Byte Order Mark for unicode if
  the user doesn't want it
  
XML2BIB
+ For users who want the bibtex file format, but not the latex encryption
  of characters, add -nl or --no-latex to command-line switches
+ Fix unicode output to add Byte Order Mark by default
+ Add -nb or --no-bom switch to turn off Byte Order Mark for unicode if
  the user doesn't want it

XML2END
+ Fix unicode output to add Byte Order Mark by default
+ Add -nb or --no-bom switch to turn off Byte Order Mark for unicode if
  the user doesn't want it

XML2ISI
+ Fix unicode output to add Byte Order Mark by default
+ Add -nb or --no-bom switch to turn off Byte Order Mark for unicode if
  the user doesn't want it

XML2RIS
+ Fix unicode output to add Byte Order Mark by default
+ Add -nb or --no-bom switch to turn off Byte Order Mark for unicode if
  the user doesn't want it

XML2WORD2007
+ Add -nb or --no-bom switch to turn off Byte Order Mark for unicode if
  the user doesn't want it
+ Fix the recognition of incollection items as book sections.


3.41
6/16/08

BUILD
+ Fix bug in makedeb.csh
+ Fix site-specific compiler definition for SunOS5 target.
+ Add Linux x86_64 target for configuration.

MODSIN
+ Fix NULL pointer dereference for "detail" elements lacking a type
  attribute.  (Noticed and hunted down by Thomas Fischer.)

RIS2XML
+ Fix bug where "AB  - " with a newline before the abstract was
  not recognized as an abstracted.  (Reported by Thomas Braun
  and Richard Mathar.)

XML2ADS
+ Updates from Richard Mathar fixing R-tag output, merging keywords,
  fixing date, adding title, and replacing double dash.
+ Update journals to current list from:
  http://adsabs.harvard.edu/abs_doc/journals1.html

XML2BIB
+ Fix character priority so unicode/utf8 takes precedence over latex
  (Patch from Luc Pardon)

3.40
2/10/08

MODSIN
+ Fix crash where placeTerm tag doesn't have attribute (Thanks to
  Martin-Michael Schoenbeck for identifying the problem and submitting
  an initial patch).
+ Properly handle the 'mods:' namespace (Thanks to Martin-Michael
  Schoenbeck for identifying the problem and submitting an 
  initial patch).
+ Fix bug where multiple roleTerms confused role assignment.

RIS2XML
+ Oxford journal RIS output is now putting DOI information in the N1
  field; recognize this (Thanks to Richard Mathar for letting me know).

XML2ADS
+ New converter for the ADS format submitted by Richard Mathar.

XML2BIB
+ Bias the program to output issue/number tags as 'number' first
  and use 'issue' only in cases where both issue and number have
  been defined.
+ Add '-sk' '--strictkey' option that only outputs alphanumeric
  characters in the bibtex reference names (this is overly strict,
  but may be useful in some cases to automatically avoid problems 
  with other bibtex parsers)

XML2END
+ Fix missing return for articles with article numbers rather than
  page numbers

XML2WORDBIB
+ Rename "xml2word" to avoid confusion with other programs that work
  on Word documents, not Word bibliographies


3.39
10/24/07

NAME MANGLING
+ Fix crash caused by specifically malformed name fields

3.38
10/10/07

BIB2XML
+ Fix crash when bibtex citation key is blank (introduced in 3.37)

END2XML
+ Fix handling of total pages
+ Fix handling of conference name

ENDX2XML
+ Fix handling of total pages
+ Fix handling of conference name
+ Fix bug where reference would skip if the starting record tag was
  split by the input buffer


3.37
8/20/07
MODSOUT
+ fix bug where terminating > symbol is missing in 
  <identifier type="serialnumber"> output

3.36
8/19/07

CHARSET CONVERSION
+ add recognition of apostrophe HTML entity

LIBRARY HANDLING
+ resolve duplicates of citation keys by adding a-z

BIB2XML
+ properly handle bibtex files output by endnote that don't have field keys
+ add support for Diploma, Doctoral, and Habilitation theses (German)

ENDX2XML
+ properly handle whitespace in style tags
+ add support for Diploma, Doctoral, and Habilitation theses (German)

RIS2XML
+ support computer program "COMP" type
+ support patent "PAT" type
+ support unpublished "UNPB" type
+ add support for Diploma, Doctoral, and Habilitation theses (German)

XML2BIB
+ output newspaper articles as @ARTICLE as well
+ output series titles as "series" for book chapter, inproceedings, theses
  types
+ add support for Diploma, Doctoral, and Habilitation theses (German)

XML2END
+ support magazine article type
+ support patent type
+ support computer program type
+ add support for Diploma, Doctoral, and Habilitation theses (German)

XML2ISI
+ be more aggressive about outputing the date

XML2RIS
+ support magazine article type
+ support abstract/summary type
+ support patent type
+ support computer program type
+ support unpublished "UNPB" type
+ add support for Diploma, Doctoral, and Habilitation theses (German)


3.35
7/30/07

BIB2XML
+ support translator field

COPAC2XML
+ fix bug where garbage input can lead to infinite loop

ENDX2XML
+ fix bug where multiple style tags caused data to be lost

ISI2XML
+ use authors listed with "AF" instead of "AU" when present as they
  are a "better" annotated list
+ fix bug where garbage input can lead to infinite loop (patch thanks
  to Fred Howell)
+ add type S for book in series
+ fix bug where NR number of references was being recognized as
  journal number

RIS2XML
+ add support for RIS magazine article "MGZN"
+ add support for RIS abstract "ABST"
+ add support for reading thesis hint in "user 1" tag "U1"

XML2BIB
+ output article number as page number if page numbers aren't found
+ support translator field
+ make preferred form of \text markups have curly brackets

XML2END
+ output article number as page number if page numbers aren't found

XML2RIS
+ output article number as page number if page numbers aren't found
+ fix recognition of thesis type
+ output "U1  - Masters thesis" or "U1  - Ph.D. thesis" as a hint
  for Refbase of the thesis type

XML2WORD
+ output article number as page number if page numbers aren't found


3.34
6/07/07

END2XML

+ fix bug that prevent dates from being read in


3.33
5/23/07

MED2XML
+ fix stupid change that caused coredumps


3.32
5/21/07

CHARSET CONVERSION
+ fix bug where UTF-8/Unicode input is ignored for BibTeX files

MODSIN
+ Recognize both &gt;extent unit="page"&lt; and &gt;extent unit="pages"&lt;

NEWSTR
+ Fix compilation on 64 bit processors

BIB2XML
+ Strip latex \url{} tags from input data

XML2BIB
+ Add recognition of --verbose and --debug

XML2END
+ Add recognition of --verbose and --debug

XML2ISI
+ Add recognition of --verbose and --debug

XML2RIS
+ Add recognition of --verbose and --debug

XML2WORD
+ Add recognition of command line switches


3.31
4/1/07

BIBTEXIN
+ Fix typo in genre for "incollection" to "monographic"
+ Remove text markups like \textit{} and \textbf{}
+ Replace text markups like "\textonesuperior" with appropriate Unicode
  characters
+ Have electronic types set MODS resource "software, multimedia"

BIBTEXOUT
+ Modify warning message for "xml2bib: cannot identify type" to
  tell user that it's defaulting to @Misc so people stop reporting
  this information to me
+ Add electronic type recognition and output

ENDIN
+ Have electronic types set MODS genre "electronic"
+ Add '%S' Series title to Book type
+ Add recognition of Unicode UTF8 byte order information

ENDXMLIN
+ Ensure that the "label" field ends up in the MODS output as
  reference ID
+ Pass through "short-title" information

MODSOUT
+ Fix typo so MARC-authority genre types are "marcgt", not "marc"
+ Output ACCESSNUM to MODS

RISIN
+ Add thesis type
+ Add report type

RISOUT
+ Map "collection" and "incollection" from bibtex to "book" and "inbook"
+ Add thesis type
+ Add report type

ENDOUT
+ Map "collection" and "incollection" from bibtex to "book" and "inbook"


3.30
3/17/07

XML2WORD
+ Write first version of the program


3.29
3/12/07

ENDIN
+ Fix addition of extraneous tag for electronic types; add
  proper MODS resource tag

ENDX2XML
+ Fix problems parsing in XML files without newlines

3.28
3/10/07

BIBTEXIN
+ Fix problems parsing files that have non-bibtex lines in them
+ Add c with a hacek support to latex characters (thanks to
  George Smith for the information)
+ Add enspace, emspace, and thinspace support to latex
  characters (patch from John Spray; thanks!)

ENDX2XML
+ Write first version of the program

ISIIN
+ Add support for DOI tag "DI"

NAME MANGLING
+ Fix bug in handling multibyte Unicode characters

XMLIN
+ Fix bug where single quoted XML attributes were not recognized
(Patch due to Jason Lerch; thanks!)

XML2ISI
+ Write first version of the program


3.26
06/21/06

MODSIN
+ Add reading in pubmed/medline/pii identifiers

RISOUT
+ Output pubmed identifiers as UR  - PM:###### (Thanks to Mark Runyan)


3.25
06/14/06

BUILD PROCESS
+ Add NetBSD, FreeBSD, and Cygwin to recognized architectures

MODSOUT
+ Convert patent assignee to the MARC term "patent holder" (modified from
  patch by Ralf Ahlbrink)
+ Add role types "organizer of meeting", "inventor", "degree grantor"
 (modified from patch by Ralf Ahlbrink)

NAME MANGLING
+ Fix possible interactions between pre-defined corporate types
  and user-defined as-is and corporate types

ISI2XML
+ Add support for "article number" (AR) field that some journals are
  now using instead of page numbers

MED2XML
+ Fix date parsing for entries that have a "medline format date" rather
  than a date broken down into XML fields
+ Fix bug that doesn't output proper end pages if first and last pages
  are the same length (thanks to Andreas Hartmetz for finding and patching
  the bug)


3.24
02/21/06

CHARSET CONVERSION
+ fix bug where requests for UTF-8 encoded output were ignored

MED2XML
+ default input to UTF-8 encoded unicode, as it ought to be
+ extract a few more items (like pubmed/medline/pii ID's, MeSH
  headings)...most currently only make it into MODS output

XML
+ fix potential core dump from empty xml attributes values

XML2BIB
+ for better compatibility with Emacs, default the bibtex tags to
  lower case
+ new switch -U, --uppercase to switch to old all uppercase tag behavior


3.23
1/02/06

Changes in this release are thanks to patch and bug report by Jeremy Malcolm.

BIB2XML
+ Add support for volume in @electronic reference type

END2XML
+ Add support for volume in electronic reference type

RIS2XML
+ Add support for TY - ELEC reference type

XML2RIS
+ Add support for TY - ELEC reference type
+ Fix bug where GENRE, but not NGENRE data was being parsed for reference
  type

3.22
12/09/05

MODSIN
+ fix off-by one bug that can cause references to be skipped

XML
+ fix potential coredump on error path in xml_findend()


3.21
11/02/05

CHARSET CONVERSION
+ add latex version of degree sign, micro sign
+ numerous fixes to charset handling
+ add -i,--input-encoding and -o, --output-encoding parameters for the
  programs xml2bib, xml2end, xml2ris
+ allow modsin and medin modules to read the character set specified by
  the xml descriptors
+ set priority so that the character set has the priority:
  program defaults < xml file specified < user specified

LIBRARY
+ fix bug where static prototype appears to be illegal and prevents
  compilation on MacOSX "Tiger"
+ finally add error reporting messages for library errors

BIB2XML
+ add support for cross referencing


3.20
10/06/05

END2XML
+ fix type of court reporter

NAME PROCESSING
+ recognize names in the form Author, HQ or HQ Author and split up
  the initials

BUILD PROCESS
+ switch build to a ./configure; make; make install commands (but do
  it without autoconf)
+ add debian package options to Linux and MacOSX as a trial

MODSOUT
+ start fixing position of items like volume, issue, pages for entries
  now that MODS v3.1 allows part tags at the main level


3.19
09/14/05

BIB2XML
+ add issuance of monographic to book types: book, inbook, incollection
+ fix bug where fields protected by braces or quotations would still
  be subjected to string substitutions
+ fix bug where string substitutions could be applied multiple times;
  bibtex has special concatenation with string substitution rules
+ add latin capital/lowercase c with acute to latex conversion
+ add some letters with caron (hacek) specifications

END2XML
+ add issuance of monographic to book types: book, edited book, chapter
+ move publisher to host level in journal article and add to magazine
  article

ISI2XML
+ add issuance of monographic to book types: book, chapter

RIS2XML
+ add issuance of monographic to book types: book, inbook

XML2BIB
+ The protected latex forms of characters, e.g. {\'A}, are preferred
  to non-protected, e.g. \'A or \'{A}.  So fixup lookup table
  so the preferred forms are output.

XML2RIS
+ better detection of book types via issuance of monographic

SERIALNUMBER
+ split out common serial number processing code

MODSIN
+ fix bug where unicode character set in was not the default

MODSOUT
+ ensure that ambiguous serial numbers are output
+ fix bug where -un/-u flags weren't being respected


3.18
07/11/05

BIB2XML
+ accomodate all entries from the IEEEtrans bibtex style and other requests
  for missing common fields
+ to article reference type add key, location, language, note, keywords
+ to book reference type add key, location, language, note, series,
  volume, number, lccn, keywords
+ to techreport reference type add key, location, language, note, institution,
  number, type, lccn, keywords
+ to inbook reference type add key, location, language, note, lccn, keywords
+ to incollection reference type add key, location, language, note, number,
  chapter, type, lccn
+ to booklet reference type add key, location, note, series, volume, number
  organization, language, lccn
+ to manual reference type add key, location, note, language, organization,
  lccn, keywords
+ to inproceedings/incollection type add key, location, note, language,
  series, number, organization, paper, type, lccn, keywords
+ to proceedings type add key, location, note, language, series, number,
  organization, lccn, keywords
+ to mastersthesis type add key, location, note, language, type, keywords
+ to phdthesis type add key, location, note, languate, type, keywords
+ to mastersthesis type add key, location, note, language, type, keywords
+ to phdthesis type add key, location, note, languate, type, keywords
+ to misc type add key, location, note, language, organization, keywords
+ add unpublished type
+ add electronic type
+ add patent type
+ add periodical type
+ add standard type

XML2BIB
+ fix recognition of collection/incollection types
+ add handling of location information

XML2END
+ output all note fields

MODSIN
+ add physical location to tags read in
+ fix memory leak in modsin_location()
+ fix bug in modsin_descriptionr()
+ keep type="school" information in place entries

MODSOUT
+ handle key field from bibtex


3.17
06/28/05
BIB2XML
+ add series information to incollection type
+ add edition input to types
+ protect URL, DOI, REFNUM fields from being detexified
+ support URLs in "howpublished" tags
+ support \url{} in addition to \urllink{}
+ inbook reference types should use chapter+title, not title+booktitle
+ incollection reference types should use booktitle+title
+ fix bug where spaces in string replacements cause the replacements to
  be misunderstood

COPAC2XML
+ fix but in name mangling and insertion of editors in author fields

ISI2XML
+ fix bug in outputing times cited to note field

RIS2XML
+ add reading user U1-U5 and miscellaneous M1-M3 fields; convert to "notes"
  so they'll be output at least

MODSIN
+ put in the core of handling physicalDescription tags
+ fix bug where files with mods ending and starting on the same line were
  mangled

MODSOUT
+ fix place term output and edition output
+ output all URL information

XML2BIB
+ add edition output
+ protect REFNUM fields from being texified
+ better error messages for misidentified TYPE
+ recognize Masters and Ph.D. thesis types
+ inbook reference types should use chapter+title, not title+booktitle
+ incollection reference types should use booktitle+title
+ fix recognition of genre magazine as ARTICLE

XML2END
+ fix bug in recognizing the thesis type


3.16
4/10/05

GLOBAL CHANGES
+ rename progs directory to bin
+ fix warnings from SunOS compile

BIB2XML
+ add masters thesis type
+ change Ph.D. thesis and Masters thesis to add non-MARC genres
  "Ph.D. thesis" and "Masters thesis" to distinguish

END2XML
+ fix bug where endin_readf() can return 0 even if reference is obtained

XML2BIB
+ don't texify special characters in URLs and DOIs


3.15
3/17/05

GLOBAL CHANGES
+ Convert all programs to use the bibutils library with bibl_read() and
  bibl_write() with appropriate modes.  Massive conversion to a bibutils
  library.
+ Add -o or --output-encoding to xml2bib, xml2end, xml2ris
+ Add -s or --single-refperfile to xml2bib, xml2end, xml2ris
+ Handle all character conversion issues nicely in the library.  Set default
  to Latin-1 (ISO 8859-1), same as web browsers.
+ Move around files to lib/, prog/, and test/ directories; fix top level make
+ Change name of struct newstring to struct newstr for consistency
+ Change cleanf() to take entire bibliographies and not just references in
  preparation for cross-referencing handling in bib2xml


BIB2XML
+ Do a nice job of translating latex codes to Unicode
+ Bump version number to 3.12

COPAC2XML
+ Bump version number to 1.2

END2XML
+ Bump version number to 3.13

ISI2XML
+ Move times cited field to notes
+ Bump version number to 2.5

MED2XML
+ Bump version number to 2.3

RIS2XML
+ Bump version number to 2.11

MODSIN
+ add URL support to identifier type="uri"

XML2BIB
+ Make sure illegal bibtex isn't outputted (including quotes when brackets
  aren't requested), and do a nice job of Unicode to latex.
+ Allow any non-space and non-tab to be output as bibtex key identifiers
+ Add URL support
+ Bump version number to 2.6

XML2END
+ fix output of ISSN/ISBN/URL/etc.
+ Bump version number to 2.3

XML2RIS
+ add number/issue output
+ Bump version number to 2.3

MODSCLEAN
+ Bump version number to 1.1


3.14
2/09/05

GLOBAL CHANGES FOR THE TOMODS CONVERTERS
+ The current programs add an underscore and the reference count to the
  reference id by default.  This is changed so that it only occurs when
  requested using the new -a or --add-refcount flags.
+ Fixed bug where the reference count wasn't used when outputting individual
  files for each reference.  This is, of course, dependent on the -a
  or --add-refcount flags.
+ change --verbose flag to only output warnings
+ add --debug flag for full output useful in hunting down problems
+ Major rewrite of the converters:
     Common framework is in lib/tomods.c
     Variables and unique function pointers defined by struct convert_rules
     Must define readf() to read a single reference from a file
     Must define processf() to convert raw input into tag/data/level in a
         field using native tags
     Define cleanf() or set to NULL to define function to clean up data
         such as LaTeX codes
     Must define convertf() to convert native tag/data/level elements into
         those appropriate for MODS XML output.

BIB2XML
+ add URL to list of recognized bibtex entries
+ bump version number to 3.11

COPAC2XML
+ bump version number to 1.1

END2XML
+ fix bug in magazine article that misplaced article title
+ fix bug that lost track of reference type information
+ bump version number to 3.12

ISI2XML
+ parse multiple keywords placed under same tag
+ bump version number to 2.4

MED2XML
+ bump version number to 2.2

RIS2XML
+ bump version number to 2.10

3.13
12/15/04

COPAC2XML
+ write first version of program

ISI2XML
+ fix bugs in handling multi-author references
+ bump version number to 2.3

END2XML
+ clean up some left over references to RIS
+ fix incrementing in waslast_tag()
+ bump version number to 3.11


3.12
11/22/04

BIB2XML
+ add support for FTP = {\urllink{http://online.ref.com}}
+ add support for TITLE = {\href{http://online.ref.com}Real Title}
+ add conversion for latex encodings character into unicode; also fixes some
  processing bugs due to names with a diaresis
+ add support for reading in digital object identifier (doi)
+ add unpublished type (and "new" genre type in MODS)
+ add proceedings type
+ add misc type
+ bump version number to 3.10

END2XML
+ switch order of "Book" and "Book Section" now that the Refer-format
  handling introduced a bug that caused both to be recognized as Book
+ bump version number to 3.10

MED2XML
+ silence compile warnings
+ pass digital object identifier (doi) information to MODS
+ bump version number to 2.1

XML2BIB
+ fix command line parsing
+ pass digital object identifier (doi) output to bibtex
+ add unpublished and misc types to output
+ bump version number to 2.5

XML2END
+ fix help message
+ bump version number to 2.2

MAKEFILE
+ fix typo in "make install" target
+ repair loss of med2xml in makefile


3.11
9/29/04

BIB2XML
+ re-write bibtex parser to handle references with missing or empty
  reference ids
+ use common title mangling
+ support table of contents
+ bump version number to 3.9

END2XML
+ use common title mangling
+ bump version number to 3.9

ISI2XML
+ use common title mangling
+ bump version number to 2.2

RIS2XML
+ use common title mangling
+ bump version number to 3.9

MODSCLEAN
+ verson 1.0 of the program

XML2BIB
+ fix bug where -fc/--final-comma isn't removed from argument list
+ merge corporate and non-corporate authors/editors into same bibtex line
+ support table of contents data
+ fix distinction between PROCEEDINGS and INPROCEEDINGS data types
+ bump version number to 2.4

MODSIN
+ make role="creator" equivalent to role="author" to handle LOC input
+ support table of contents data

MODSOUT
+ support table of contents data

TITLE
+ merge all copies of title mangling into library

XML
+ properly handle XML comments in files


3.10
09/23/04

BIB2XML
+ add explicit fflushes to try and help python deadlocks
+ bump version number to 3.8

END2XML
+ add explicit fflushes to try and help python deadlocks
+ fix typo in "Conference Proceedings" type
+ bump version number to 3.8

ISI2XML
+ handle processing of names with and without commas properly
+ bump version number to 2.1

MED2XML
+ write MODS version of converter
+ set version to 2.0

RIS2XML
+ handle processing of names with and without commas properly
+ bump version number to 2.8

XML2BIB
+ output author/year combo when REFNUM is not already defined
+ add keyword, abstract, note to output
+ bump version number to 2.3

MODSIN
+ fix merging of placeTerm when both by code and by text are present

MODSOUT
+ add explicit fflushes to try and help python deadlocks

NAME
+ merge all functions for name mangling into library


3.9
09/01/04

BIB2XML
+ convert "." to ". " in names so that names like G.P. Smith don't lose
  information
+ bump version number to 3.7

END2XML
+ modify parser so that refer-style bibliographies are handled naturally
+ convert "." to ". " in names so that names like G.P. Smith don't lose
  information
+ bump version number to 3.7

ISI2XML
+ write new MODS version
+ bump version number to 2.0

RIS2XML
+ use newstr_trimendingws
+ convert "." to ". " in names so that names like G.P. Smith don't lose
  information
+ bump version number to 2.7

XML2BIB
+ add corporate authors/editors to output
+ bump version number to 2.2

XML2RIS
+ add corporate authors/editors to output
+ bump version number to 2.2

MODSIN
+ convert numeric month to name
+ handle multiple roles per person
+ prevent unnecessary decents through the XML tree structure
+ fix core dump in modsin_detailr due to copy/paste bug
+ fix role processing in corporation names

MODSOUT
+ some code cleanups
+ if a reference ID cannot be found, first try to output one based
  on the first author and four-digit year and refnum, eg. Jones2000_123,
  and then default to a ref#### ID

NEWSTR
+ add newstr_trimendingws

XML
+ fix identification of tags like &lt;title/&gt; that scrambled the XML
  hierarchy


version 3.8
07/29/04

XML2BIB
+ fix bug in command line parsing
+ fix bug where ending commas are missing
+ add periods after abbreviated given names
+ bump version number to 2.1

XML2END
+ add periods after abbreviated given names
+ bump version number to 2.1

XML2RIS
+ add periods after abbreviated given names
+ bump version number to 2.1

MODSIN
+ handle pages either as details or extents

MODSOUT
+ fix bug where empty names were output
+ if given names are abbreviations, e.g. "A. B. Jones", drop periods
+ write out single pages as details, not extents


version 3.7
07/26/04

BIB2XML
+ fix bug where multi-line authors w/o trailing spaces were merged
+ add publisher and address fields to book and report types
+ add/fix genre output to many reference types
+ add support for given name separation for MODSOUT
+ add issue field to article type
+ bump version number to 3.6

END2XML
+ add support for given name separation for MODSOUT
+ add/fix genre output to many reference types
+ fix core dump on empty input
+ bump version number to 3.6

RIS2XML
+ add support for given name separation for MODSOUT
+ handle case where last reference in file is missing end tag
+ add/fix genre/typeOfResource output to many reference types
+ bump version number to 2.6

XML2BIB
+ write first MODS version of the program
+ bump version number to 2.0

XML2END
+ write first MODS version of the program
+ bump version number to 2.0

XML2RIS
+ write first MODS version of the program
+ bump version number to 2.0

FIELDS
+ add function fields_maxlevel()

MODSOUT
+ add support for separating each part of the given name to a separate
  namePart construct
+ write out given names before family name
+ ensure that both start and end elements are written when page
  extents are output

NEWSTRING
+ add newstr_toupper(), newstr_prepend() functions

version 3.6
6/1/04

BIB2XML
+ bump version number to 3.5

END2XML
+ bump version number to 3.5

RIS2XML
+ clean up reference parsing loop as per end2xml from bibutils v 2.16
+ fix missing break statement in process_cite that put titles into dates
+ move abstracts marked by "N2" into the main record, not host
+ bump version number to 2.5

MODSOUT
+ move part element of relatedItems to the very last element outputted
  (needs to be after identifier and .xsd would suggest that it should be
  the last item)

version 3.5

BIB2XML
+ clean up name processing
+ add corporation recognition for names
+ add -c, --corporation-file to input corporation names
+ add genre type periodical to journal articles
+ bump version number 3.4

END2XML
+ add genre type periodical to journal articles
+ add genre type periodical to magazines
+ add genre type thesis to thesis
+ fix read_refs() to not require leading %0 as per version 2.16
+ use fields_init()
+ clean up name processing
+ add -c, --corporation-file to  input corporation names
+ bump version number 2.5

RIS2XML
+ add genre type periodical to journal articles
+ clean up name processing
+ add corporation recognition for names
+ add -c, --corporation-file to input corporation names
+ bump version number 2.4

MODSOUT
+ separate genre output into own function, have it automatically detect
  genre terms under the "marc authority", make sure genre type is properly
  unicode formated, allow multiple genres to be output per level of 
  reference
+ separate typeofResource output into own function, and have it make sure
  that output matches the legal values, generate error if it doesn't
+ handle corporation name output

version 3.4
1/31/04

BIB2XML
+ add "?" as title/subtitle separator like ":"
+ bump version to 3.3

END2XML
+ add "?" as title/subtitle separator like ":"
+ bump version to 2.4

RIS2XML
+ do some reference type/tag additions
+ fix bug where titles weren't being put in output
+ add "?" as title/subtitle separator like ":"
+ bump version to 2.3

MODSOUT
+ fix shorttitle output so that if long version has subtitle,
  shorttitle is always output...otherwise only output if
  shorttitle is different than long title

version 3.3
1/24/04

END2XML
+ correct typeOfResource "software" to "software, multimedia"
+ have shorttitles terminate at colons
+ bump version to 2.3

MODOUTS
+ allow single and double quotes to be placed directly in output

version 3.2
1/22/04

BIB2XML
+ add -un/--unicode-no-bom option for writing unicode w/o adding the
  byte order mark at the beginning of the file
+ assign dates in part and in dateIssued by reference type
+ bump version to 3.2

END2XML
+ add -un/--unicode-no-bom option for writing unicode w/o adding the
  byte order mark at the beginning of the file
+ fix LEVEL_HOST/LEVEL_MAIN mismatches for reference types
+ assign dates in part and in dateIssued by reference type
+ bump version to 2.2

RIS2XML
+ add -un/--unicode-no-bom option for writing unicode w/o adding the
  byte order mark at the beginning of the file
+ assign dates in part and in dateIssued by reference type
+ bump version to 2.2

MODSOUT
+ convert to proper UTF-8 output
+ put "ref" in front of all numeric ID cite key for compliance with
  MODS DTD "rules"
+ protect mods ID from output illegal characters and IDs that start
  with non-alphanumerics
+ fix over-zealousness of fields_find()
+ distinguish between dates that fall in &lt;part&gt; and those
  in &lt;dateIsssued&gt;


version 3.1
1/21/04

BIB2XML
+ add -d/--drop-key option
+ bump version to 3.1

END2XML
+ add -d/--drop-key option
+ fix loss of year output for newspaper article type
+ fix moving picture/moving image issue for film type
+ bump version to 2.1

RIS2XML
+ add -d/--drop-key option
+ bump version to 2.1

MODSOUT
+ fix bug where part is output in main level
+ add mods ID for cite key, controllable by -d/--drop-key

version 3.0
1/20/04

BIB2XML
+ new version 3.0

END2XML
+ new version 2.0

RIS2XML
+ new version 2.0
